  PROGRAM
  MAP
    Insert_Data(long pRecs,String pType,*Long pElapsed),Long
    Update_Data(String pType,*Long pSelectTime,*Long pUpdateTime),Long
    Delete_Data(String pType,*Long pElapsed),Long
    Show_Data()
    Create_DynamicMemTable()
    Lock_Database(String pInstallBusyHandler,String pXPos)
  END


Include('SQLite.INC'),Once

SQLite      Class(SQLiteType),Thread
            End


TPSFile    FILE,DRIVER('TopSpeed'),PRE(TPS),CREATE
RecIDKey      KEY(TPS:RecID),OPT,NOCASE,PRIMARY
CharKey       KEY(TPS:Char),DUP,OPT,NOCASE
StrKey        KEY(TPS:Str),DUP,OPT,NOCASE
DecKey        KEY(TPS:Dec),DUP,OPT,NOCASE
CharStrDecKey KEY(TPS:Char,TPS:Str,TPS:Dec),DUP,OPT,NOCASE
Record        RECORD
RecID           LONG
Char            BYTE
Str             CSTRING(64)
Dec             Decimal(15,3)
Real            Real
              END
           END



Loc:Recs            Long(25000)
Loc:TPS_Elapsed     Long
Loc:SQLite_Elapsed  Long

Loc:SQLReads        Long
Loc:TPSUpds         Long
Loc:TPSReads        Long
Loc:SQLUpds         Long

Loc:SQLDelTime      Long
Loc:TPSDelTime      Long

Loc:XPos            Long
Loc:Width           Long
Loc:Pos             String(5)




Window WINDOW('Sample Program to embed SQLite'),AT(,,219,177),FONT('MS Sans Serif',8,,FONT:regular),CENTER, |
         ICON('sqlite.ico'),GRAY
       IMAGE('sqlite.JPG'),AT(0,0,219,62),USE(?Image1)
       SPIN(@n9),AT(60,68,53,10),USE(Loc:Recs)
       STRING('Records/Rows'),AT(1,68),USE(?String1)
       BUTTON('Generate Data'),AT(131,68,65,14),USE(?GenButton)
       STRING('Read using different Keys/Indexes'),AT(12,92),USE(?String2)
       BUTTON('Show Data'),AT(131,92,65,14),USE(?ShowButton)
       STRING('Dynamic Memory Table'),AT(47,116),USE(?String3)
       BUTTON('Dyn.Mem.Table'),AT(131,116,65,14),USE(?DynMemButton)
       STRING('Simulate DB Locking '),AT(53,140),USE(?String5)
       BUTTON('Lock Test'),AT(132,140,65,14),USE(?LockButton)
       STRING('Performance Tests are Measured in hundreds of a sec.'),AT(4,164,210,10),CENTER
     END

    CODE
    OPEN(Window)
    ACCEPT
        Case Event()
        Of Event:OpenWindow
            ?Loc:Recs{Prop:Step} = 1000
            Open(TPSFile)
            If ~ErrorCode()
                Loc:Recs = Records(TPSFile)
                Close(TPSFile)
            End
        Of Event:Accepted
            Case Field()
            Of ?GenButton
                If  Loc:Recs%2=1
                    Message('Please use an even number of Records')
                    Cycle
                End
                If  Loc:Recs=0
                    Message('Please enter number of records/rows to generate')
                    Cycle
                End
                Case Message('This process may take some time.<13,13>' &|
                             'Insert ' & Loc:Recs*2 & '<13>' &|
                             'Update ' & Loc:Recs   & '<13>' &|
                             'Delete ' & Loc:Recs   & '<13><13>' &|
                             'This is performed for both SQLite and TPS.<13>' &|
                             'Do you wish to Continue?','Generate Data',Icon:Question,Button:Yes+Button:No)
                Of Button:No
                    Cycle
                End

                !Start Processing
                If ~Insert_Data(Loc:Recs*2,'SQLite',Loc:SQLite_Elapsed) |
                Or ~Insert_Data(Loc:Recs*2,'TPS'   ,Loc:TPS_Elapsed)    |
                Or ~Update_Data('TPS'   ,Loc:SQLReads,Loc:TPSUpds)      |
                Or ~Update_Data('SQLite',Loc:TPSReads,Loc:SQLUpds)      |
                Or ~Delete_Data('TPS',Loc:TPSDelTime)                   |
                Or ~Delete_Data('SQL',Loc:SQLDelTime)
                    Cycle
                End

                Message('SQLiteDB Inserted '           & Loc:Recs*2 & ' rows in ' & Loc:SQLite_Elapsed & '<13>' &|
                        'TPSFile  Inserted '           & Loc:Recs*2 & ' recs in ' & Loc:TPS_Elapsed    & '<13>' &|
                        'SQLiteDB Updated '            & Loc:Recs   & ' rows in ' & Loc:SQLUpds        & '<13>' &|
                        'TPSFile  Updated '            & Loc:Recs   & ' recs in ' & Loc:TPSUpds        & '<13>' &|
                        'SQLite   Deleted '            & Loc:Recs   & ' rows in ' & Loc:SQLDelTime     & '<13>' &|
                        'TPSFile  Deleted '            & Loc:Recs   & ' recs in ' & Loc:TPSDelTime     & '<13>' &|
                        'SQLiteDB Read (Primary Key) ' & Loc:Recs   & ' rows in ' & Loc:SQLReads       & '<13>' &|
                        'TPSFile  Read (Primary Key) ' & Loc:Recs   & ' recs in ' & Loc:TPSReads       & '<13>' &|
                         '<13>Measured in hundreds of a sec.','Performance Comparison')

            Of ?ShowButton
                If ~Exists('TPSFile.TPS') |
                Or ~Exists('SQLite.DB')
                    Message('Please first Generate Data')
                    Cycle
                End
                Show_Data()

            Of ?DynMemButton
                If ~Exists('TPSFile.TPS') |
                Or ~Exists('SQLite.DB')
                    Message('Please first Generate Data')
                    Cycle
                End
                Create_DynamicMemTable()

            Of ?LockButton
                If ~Exists('TPSFile.TPS') |
                Or ~Exists('SQLite.DB')
                    Message('Please first Generate Data')
                    Cycle
                End

                Loc:XPos  = 0{Prop:At,1}
                Loc:Width = 0{Prop:At,3}
                Loc:Pos   = Loc:XPos + Loc:Width
                Case Message('Install Busy Handler','Handle Locking',Icon:Question,Button:Yes+Button:No)
                Of  Button:Yes
                    Start(Lock_Database,,'1',Loc:Pos)
                    Start(Lock_Database,,'1',Loc:Pos)
                Else
                    Start(Lock_Database,,'0',Loc:Pos)
                    Start(Lock_Database,,'0',Loc:Pos)
                End
            End

        End
    End
    CLOSE(Window)


Insert_Data Procedure(Long pRecs,String pType,*Long pElapsed)
ProgressWindow WINDOW('Progress...'),AT(,,180,59),CENTER,GRAY
       PROGRESS,USE(?ProgressBar),AT(8,15,164,12),RANGE(0,100)
       BUTTON('Cancel'),AT(65,39,50,15),USE(?CancelButton)
     END
Loc:Begin   Long
Loc:Count   Long
Loc:Index   Long
Loc:Str     cString(50)
Loc:Char    Byte
Loc:Dec     Decimal(15,3)
Loc:Real    Real
Loc:RecID   Long

Loc:Cancel  Long(False)

    Code
    Open(ProgressWindow)
    Accept
        Case Event()
        Of Event:OpenWindow
            Loc:Begin = Clock()
            Case pType
            Of 'SQLite'
                0{Prop:Text} = 'SQLite Database Table generation of ' & pRecs & ' rows'

                If  Exists('SQLite.DB')
                    If  SQLite.hSQLite
                        SQLite.CloseDB()
                    End
                    Remove('SQLite.DB')
                End

                If ~SQLite.OpenDB('SQLite.DB')
                    Message('Unable to Open SQLite DB')
                    Post(Event:CloseWindow)
                    Cycle
                End

                SQLite.SQL ='DROP TABLE IF EXISTS SQLiteTable;' & |
                        'CREATE TABLE SQLiteTable (RecID INTEGER PRIMARY KEY, Char INTEGER NOT NULL, Str TEXT NOT NULL COLLATE NOCASE, Dec REAL NOT NULL,Real REAL NOT NULL);' & |
                        'CREATE INDEX CharKey       ON SQLiteTable (Char);' & |
                        'CREATE INDEX StrKey        ON SQLiteTable (Str);' & |
                        'CREATE INDEX DecKey        ON SQLiteTable (Dec);' & |
                        'CREATE INDEX CharStrDecKey ON SQLiteTable (Char,Str,Dec)'
                If ~SQLite.Exec()
                    Post(Event:CloseWindow)
                    Cycle
                End


            Of 'TPS'
                0{Prop:Text} = 'TPSFile Generation of ' & pRecs & ' records'
                Close(TPSFile)
                Create(TPSFile)
                If  ErrorCode()
                    Message('Unable to create TPSFile ErrorCode='&ErrorCode())
                    Post(Event:CloseWindow)
                    Cycle
                End
                Open(TPSFile,18)    !Read write, Deny All
                If  ErrorCode()
                    Message('Unable to Open TPSFile ErrorCode='&ErrorCode())
                    Post(Event:CloseWindow)
                    Cycle
                End
            End

            0{Prop:Timer} = 1

        Of Event:Accepted
            Case Field()
            Of ?CancelButton
               0{Prop:Timer} = 0
               Loc:Cancel = True
               Post(Event:CloseWindow)
            End

        Of Event:Timer
            Case pType
            Of 'SQLite'
                SQLite.Exec('BEGIN TRANSACTION')
            Of 'TPS'
                Logout(1,TPSFile)
            End
            Loop 1000 Times
                If  Loc:Count>=pRecs
                    0{Prop:Timer} = 0
                    Post(Event:CloseWindow)
                    Break
                End

                Loc:Count+= 1

                !Generate some Random Data
                Loc:RecID = pRecs-Loc:Count+1
                Loc:Char  = Random(0,255)
                Loop Loc:Index = 1 to 45
                    Loc:Str[Loc:Index] = Chr(Random(65,122))    !0-127 the same in UTF8
                End
                Loc:Str[46] = '<0>'
                Loc:Dec     = Random(-999999999,999999999)
                Loc:Real    = Random(-999999999,999999999)

                Case pType
                Of 'SQLite'
                    SQLite.SQL = 'INSERT INTO SQLiteTable (RecID,Char,Str,Dec,Real) VALUES (' & |
                        Loc:RecID & ',' & Loc:Char & ', "' & Loc:Str & '",' & Loc:Dec & ',' & Loc:Real & ')'
                    SQLite.Exec()
                Of 'TPS'
                    TPS:RecID = Loc:RecID
                    TPS:Char  = Loc:Char
                    TPS:Str   = Loc:Str
                    TPS:Dec   = Loc:Dec
                    TPS:Real  = Loc:Real
                    Add(TPSFile)
                End
            End
            Case pType
            Of 'SQLite'
                SQLite.Exec('COMMIT')
            Of 'TPS'
                Commit
            End
            ?ProgressBar{Prop:Progress} = Loc:Count / pRecs * 100

        Of Event:CloseWindow
            Case pType
            Of 'SQLite'
                SQLite.CloseDB()
            Of 'TPS'
                Close(TPSFile)
            End
            pElapsed = Clock()-Loc:Begin
        End
    End
    Close(ProgressWindow)
    If  Loc:Cancel
        Return False
    Else
        Return True
    End


Update_Data Procedure(String pType,*Long pSelectTime,*Long pUpdateTime)

DataQ           Queue
RecID               LONG
Char                BYTE
Str                 CSTRING(64)
Dec                 Decimal(15,3)
Real                Real
                End

SyncWindow WINDOW('Sync Databases'),AT(,,180,59),CENTER,GRAY
       PROGRESS,USE(?Progress),AT(8,15,164,12),RANGE(0,100)
     END

Loc:TPSRecs     Long
Loc:SQLiteRecs  Long

Loc:TPSRead     Long
Loc:TPSUpd      Long
Loc:SQLiteRead  Long
Loc:SQLiteUpd   Long

CountQ          Queue
Count               Long
                End

Loc:BeginTime   Long
Loc:RecCount    Long
Loc:Records     Long
Loc:Process     Long
                Itemize
eReadTPS            Equate
eUpdSQLite          Equate
eUpdTPS             Equate
                End


    !***************************************************************************************
    !This procedure will ensure the same data exists in SQLite and TPS files.
    !Load the 2nd half of the SQLite data into a Queue and then update it to the TPSFile
    !Load the 1st half of the TPS    data into a Queue and then update it to the SQLite DB
    !***************************************************************************************

    Code
    Open(SyncWindow)
    Accept
        Case Event()
        Of Event:OpenWindow
            Case pType
            Of 'SQLite'
                If ~SQLite.OpenDB('SQLite.DB')
                    Message('Unable to Open SQLite DB')
                    Post(Event:CloseWindow)
                End
                SQLite.CallBackQ &= CountQ
                SQLite.Exec('SELECT COUNT(*) FROM SQLiteTable')

                0{Prop:Text} = 'Sync Databases - Read ' & CountQ.Count/2 & ' TPSFile Records'
                ?Progress{Prop:Progress} = 0
                Loc:BeginTime = Clock()
                Open(TPSFile,16)
                If  ErrorCode()
                    Message('Unable to Open TPSFile ErrorCode='&ErrorCode())
                    Post(Event:CloseWindow)
                    Cycle
                End
                TPS:RecID = CountQ.Count/2 + 1
                Set(TPS:RecIDKey,TPS:RecIDKey)
                Loc:Process = eReadTPS
                Loc:Records = CountQ.Count/2
                Loc:RecCount= 0
                0{Prop:Timer} = 1


            Of 'TPS'
                Open(TPSFile,18)    !Read/Write, Deny All
                If  ErrorCode()
                    Message('Unable to Open TPSFile ErrorCode='&ErrorCode())
                    Post(Event:CloseWindow)
                    Cycle
                End
                Loc:TPSRecs = Records(TPSFile)

                0{Prop:Text} = 'Sync Databases - Read ' & Loc:TPSRecs/2 & ' SQLite Rows'
                ?Progress{Prop:Progress} = 0
                Loc:BeginTime = Clock()
                If ~SQLite.OpenDB('SQLite.DB')
                    Message('Unable to Open SQLite DB')
                    Post(Event:CloseWindow)
                End
                SQLite.CallbackQ &= DataQ
                SQLite.ProgressControl = ?Progress
                SQLite.ProgressTotal   = Loc:TPSRecs/2
                SQLite.Exec('SELECT * FROM SQLiteTable where RecID <<= ' & Loc:TPSRecs/2)
                Loc:SQLiteRead = Clock()-Loc:BeginTime

                !Populate to TPS
                0{Prop:Text} = 'Sync Databases - Update ' & Records(DataQ) & ' TPSFile Records'
                Loc:BeginTime = Clock()
                Loc:Process   = eUpdTPS
                Loc:RecCount  = 0
                Loc:Records   = Loc:TPSRecs/2
                0{Prop:Timer} = 1
            End

        Of  Event:Timer
            Case pType
            Of 'TPS'
                Case Loc:Process
                Of  eUpdTPS
                    Logout(1,TPSFile)
                    Loop 1000 Times
                        Loc:RecCount += 1
                        Get(DataQ,Loc:RecCount)
                        If  ErrorCode()
                            0{Prop:Timer} = 0
                            Break
                        End
                        TPS:RecID = DataQ.RecID
                        Get(TPSFile,TPS:RecIDKey)
                        If ~ErrorCode()
                            TPS:Char = DataQ.Char
                            TPS:Str  = DataQ.Str
                            TPS:Dec  = DataQ.Dec
                            TPS:Real = DataQ.Real
                            Put(TPSFile)
                        End
                    End
                    Commit
                    ?Progress{Prop:Progress} = Loc:RecCount*100/Loc:Records
                    If  0{Prop:Timer} = 0
                        Loc:TPSUpd = Clock()-Loc:BeginTime
                        pSelectTime = Loc:SQLiteRead
                        pUpdateTime = Loc:TPSUpd
                        Post(Event:CloseWindow)
                    End
                End

            Of 'SQLite'
                Case Loc:Process
                Of  eReadTPS
                    Loop 1000 times
                        Next(TPSFile)
                        If  ErrorCode()
                            Loc:TPSRead = Clock()-Loc:BeginTime
                            ?Progress{Prop:Progress} = 100
                            !Now Update SQLite Process
                            0{Prop:Text} = 'Sync Databases - Update ' & Records(DataQ) & ' SQLite Rows'
                            ?Progress{Prop:Progress} = 0
                            Loc:Process = eUpdSQLite
                            Loc:RecCount = 0
                            Loc:BeginTime = Clock()
                            Break
                        End
                        DataQ :=: TPS:Record
                        Add(DataQ)
                        Loc:RecCount+=1
                    End
                    ?Progress{Prop:Progress} = Loc:RecCount*100/Loc:Records

                Of eUpdSQLite
                    SQLite.Exec('BEGIN TRANSACTION')
                    Loop 1000 Times
                        Loc:RecCount += 1
                        Get(DataQ,Loc:RecCount)
                        If  ErrorCode()
                            0{Prop:Timer} = 0
                            Break
                        End
                        SQLite.SQL = 'UPDATE SQLiteTable SET Char = ' & DataQ.Char &|
                                                          ', Str  = "' & Clip(DataQ.Str) & '"' &|
                                                          ', Dec  = ' & DataQ.Dec &|
                                                          ', Real = ' & DataQ.Real &|
                                                          '  WHERE RecID = ' & DataQ.RecID
                        If ~SQLite.Exec()
                            Break
                        End
                    End
                    SQLite.Exec('COMMIT')
                    ?Progress{Prop:Progress} = Loc:RecCount*100/Loc:Records
                    If  0{Prop:Timer} = 0
                        Loc:SQLiteUpd = Clock()-Loc:BeginTime
                        pSelectTime = Loc:TPSRead
                        pUpdateTime = Loc:SQLiteUpd
                        Post(Event:CloseWindow)
                    End
                End
            End

        Of Event:CloseWindow
            Close(TPSFile)
            SQLite.CloseDB()
            Free(CountQ)
            Free(DataQ)
        End
    End
    Close(SyncWindow)
    Return True


Delete_Data         Procedure(String pType,*Long pElapsed)

ProgressWindow WINDOW('Progress...'),AT(,,142,59),CENTER,TIMER(1),GRAY,DOUBLE
       PROGRESS,USE(?Progressbar),AT(15,15,111,12),RANGE(0,100)
     END

Loc:RecCount        Long
Loc:Records         Long
Loc:BeginTime       Long
CountQ              Queue
Count                   Long
                    End

Loc:End             Long(False)


                    Code
                    Open(ProgressWindow)
                    Accept
                        Case Event()
                        Of  Event:OpenWindow
                            SetCursor(Cursor:Wait)
                            Loc:BeginTime=Clock()

                            If  pType = 'TPS'
                                0{Prop:Text} = 'Delete half the TPSFile Records'
                                Close(TPSFile)
                                Open(TPSFile)   !Exclusive access
                                If  ErrorCode()
                                    Message('Unable to Open TPSFile ErrorCode='&ErrorCode())
                                    Post(Event:CloseWindow)
                                    Cycle
                                End
                                Loc:Records = Records(TPSFile) / 2
                                TPS:RecID = Loc:Records+1
                                Set(TPS:RecIDKey,TPS:RecIDKey)
                                Loop
                                    Logout(1,TPSFile)
                                    Loop 1000 Times
                                        Next(TPSFile)
                                        If  ErrorCode()
                                            Loc:End=True
                                            Break
                                        End
                                        Delete(TPSFile)
                                        Loc:RecCount+=1
                                    End
                                    Commit
                                    ?ProgressBar{Prop:Progress} = Loc:RecCount * 100 / Loc:Records
                                    If  Loc:End
                                        Close(TPSFile)
                                        Post(Event:CloseWindow)
                                        Break
                                    End
                                End
                            Else
                                0{Prop:Text} = 'Delete half the SQLite Records'
                                If ~SQLite.OpenDB('SQLite.DB')
                                    Message('Unable to Open SQLite DB')
                                    Post(Event:CloseWindow)
                                    Cycle
                                End
                                SQLite.CallBackQ &= CountQ
                                SQLite.Exec('SELECT COUNT(*) FROM SQLiteTable')
                                SQLite.ProgressControl = ?Progressbar
                                SQLite.Exec('DELETE FROM SQLiteTable WHERE RecID > '& CountQ.Count/2)
                                SQLite.CloseDB()
                                Loc:End=True
                                Free(CountQ)
                                Post(Event:CloseWindow)
                            End
                        Of  Event:CloseWindow
                            SetCursor()
                            pElapsed = Clock()-Loc:BeginTime
                        End
                    End
                    Close(ProgressWindow)
                    Return (Loc:End)




Show_Data           Procedure()

DataQ               Queue,Type
RecID                   LONG
Char                    BYTE
Str                     CSTRING(64)
Dec                     Decimal(15,3)
Real                    Real
                    End

SQLiteDataQ         Queue(DataQ)
                    End

TPSDataQ            Queue(DataQ)
                    End

Loc:BeginTime       Long
Loc:TPSFileTime     Long
Loc:SQLiteTime      Long

CountQ              Queue
Count                   Long
                    End
Loc:Count           Long
Loc:Total           Long
Loc:Interval        Long

Loc:Order           Long
eOrder_Primary      Equate(1)
eOrder_CharStrDec   Equate(2)
eOrder_Dec          Equate(3)
eCancel             Equate(4)


ShowWindow WINDOW('Show Databases'),AT(,,400,294),CENTER,SYSTEM,GRAY
       PROGRESS,USE(?SQLiteProgress),AT(22,7,172,10),RANGE(0,100)
       STRING('SQLite Data'),AT(22,7,172,10),USE(?SQLiteMsg),CENTER,FONT(,,,FONT:bold,CHARSET:ANSI),Hide
       LIST,AT(22,20,172,262),USE(?SQLiteList),HIDE,HVSCROLL,FORMAT('40R(2)|M~RecID~@n_9@20R(2)|M~Byte~@n3@112L(2)|M~String~@S64@63R(2)|M~Decimal~@n-' &|
           '15@20L(2)|M~Real~@n-15@'),FROM(SQLiteDataQ)
       PROGRESS,USE(?TPSFileProgress),AT(206,7,172,10),RANGE(0,100)
       STRING('TPSFile Data'),AT(206,7,172,10),USE(?TPSFileMsg),CENTER,FONT(,,,FONT:bold,CHARSET:ANSI),Hide
       LIST,AT(206,20,172,262),USE(?TPSList),HIDE,HVSCROLL,FORMAT('40R(2)|M~RecID~@n_9@20R(2)|M~Byte~@n3@112L(2)|M~String~@S64@63R(2)|M~Decimal~@n-' &|
           '15@20L(2)|M~Real~@n-15@'),FROM(TPSDataQ)
     END


    Code
    Open(ShowWindow)
    0{Prop:Hide} = True
    Accept
        Case Event()
        Of Event:OpenWindow

            Loc:Order = Message('Select Key/Index for order<13>The TPS file is marginally quicker using the Primary Key, otherwise SQLite is quicker.','Select Key',ICON:Question,'Primary Key|Complex Key|Decimal Key|Cancel',eOrder_CharStrDec)
            Case Loc:Order
            Of  eCancel
                Post(Event:CloseWindow)
                Cycle
            Of  eOrder_Primary
                0{Prop:Text} = 0{Prop:Text} & ' (Order By Primary RecID)'
            Of  eOrder_Dec
                0{Prop:Text} = 0{Prop:Text} & ' (Order By Dec Key)'
            Else
                0{Prop:Text} = 0{Prop:Text} & ' (Order By Char,Str,Dec)'
            End
            0{Prop:Hide} = False

            !Populate SQLiteDataQ
            Loc:BeginTime = Clock()
            If ~SQLite.OpenDB('SQLite.DB')
                Message('Unable to Open SQLite DB')
                Post(Event:CloseWindow)
                Cycle
            End
            SQLite.CallBackQ &= CountQ
            SQLite.Exec('SELECT COUNT(*) FROM SQLiteTable')

            SQLite.CallbackQ &= SQLiteDataQ
            SQLite.ProgressControl  = ?SQLiteProgress
            SQLite.ProgressTotal    = CountQ.Count
            Case Loc:Order
            Of  eOrder_Primary
                SQLite.Exec('SELECT * FROM SQLiteTable ORDER BY RecID')
            Of  eOrder_Dec
                SQLite.Exec('SELECT * FROM SQLiteTable ORDER BY Dec')
            Else
                SQLite.Exec('SELECT * FROM SQLiteTable ORDER BY Char,Str,Dec')
            End
            Loc:SQLiteTime = Clock()-Loc:BeginTime
            ?SQLiteProgress{Prop:Hide} = True
            ?SQLiteList    {Prop:Hide} = False
            ?SQLiteMsg     {Prop:Text} = 'SQLite read '  & Records(SQLiteDataQ) & ' in ' & Loc:SQLiteTime  & ' (hundreds of a sec.)'
            ?SQLiteMsg     {Prop:Hide} = False
            Display(?SQLiteMsg,?SQLiteList)


            !Populate TPSDataQ
            Loc:BeginTime = Clock()
            Close(TPSFile)
            Open(TPSFile,16)
            If  ErrorCode()
                Message('Unable to Open TPSFile ErrorCode='&ErrorCode())
                Post(Event:CloseWindow)
                Cycle
            End
            Loc:Count = 0
            Loc:Total = Records(TPSFile)
            Loc:Interval = Loc:Total / 25
            Clear(TPS:Record)
            Case Loc:Order
            Of  eOrder_Primary
                Set(TPS:RecIDKey,TPS:RecIDKey)
            Of  eOrder_Dec
                Clear(TPS:Dec,-1)
                Set(TPS:DecKey,TPS:DecKey)
            Else
                Set(TPS:CharStrDecKey,TPS:CharStrDecKey)
            End
            Loop
                Next(TPSFile)
                If  ErrorCode()
                    ?TPSFileProgress{Prop:Progress} = 100
                    Break
                End
                TPSDataQ :=: TPS:Record
                Add(TPSDataQ)
                Loc:Count += 1
                If  Loc:Count % Loc:Interval = 0
                    ?TPSFileProgress{Prop:Progress} = Loc:Count * 100 / Loc:Total
                End
            End
            Close(TPSFile)
            Loc:TPSFileTime = Clock()-Loc:BeginTime
            ?TPSFileProgress{Prop:Hide} = True
            ?TPSList        {Prop:Hide} = False
            ?TPSFileMsg     {Prop:Text} = 'TPSFile read ' & Records(TPSDataQ)    & ' in ' & Loc:TPSFileTime & ' (hundreds of a sec.)'
            ?TPSFileMsg     {Prop:Hide} = False
            Display(?TPSFileMsg,?TPSList)

        Of Event:CloseWindow
            Free(CountQ)
            Free(SQLiteDataQ)
            Free(TPSDataQ)
        End
    End
    Close(ShowWindow)
    Return



Create_DynamicMemTable     Procedure()

DataQ           Queue,Type
RecID               LONG
Char                BYTE
Str                 CSTRING(64)
Dec                 Decimal(15,3)
                End

MemQ            Queue(DataQ)
                End

SQLiteQ         Queue(DataQ)
                End

CountQ          Queue
Count               Long
                End

Loc:MemTime     Long
Loc:SQLiteTime  Long
Loc:BeginTime   Long

Loc:UseSeqorName    Long
eByQOrdinalNo       Equate(1)
eByQFieldName       Equate(2)
eCancel             Equate(3)
Loc:RandomCount     Long

DMWindow WINDOW('Attach a :Memory: Database'),AT(,,400,294),CENTER,SYSTEM,GRAY
       PROGRESS,USE(?RandomProgress),AT(22,7,356,8),RANGE(0,100),Hide
       STRING('SQLite MEMORY Data'),AT(22,7,172,10),USE(?SQLiteMemMsg),HIDE,CENTER,FONT(,,,FONT:bold,CHARSET:ANSI)
       LIST,AT(22,20,172,262),USE(?MemList),HIDE,HVSCROLL,FORMAT('40R(2)|M~RecID~@n_9@20R(2)|M~Byte~@n3@180L(2)|M~String~@S64@63R(2)|M~Decimal~@n-' &|
           '15@'),FROM(MemQ)
       STRING('SQLite Data'),AT(206,7,172,10),USE(?SQLiteMsg),HIDE,CENTER,FONT(,,,FONT:bold,CHARSET:ANSI)
       LIST,AT(206,20,172,262),USE(?SQLiteList),HIDE,HVSCROLL,FORMAT('40R(2)|M~RecID~@n_9@20R(2)|M~Byte~@n3@180L(2)|M~String~@S64@63R(2)|M~Decimal~@n-' &|
           '15@'),FROM(SQLiteQ)
     END

                Code

                Open(DMWindow)
                Accept
                    Case Event()
                    Of Event:OpenWindow
                        If ~SQLite.OpenDB('SQLite.DB')
                            Message('Unable to Open SQLite DB')
                            Post(Event:CloseWindow)
                            Cycle
                        End
                        SQLite.CallBackQ &= CountQ
                        SQLite.Exec('SELECT COUNT(*) FROM SQLiteTable')
                        SQLite.Exec('ATTACH '':memory:'' AS Mem')
                        SQLite.SQL = |
                        'CREATE TABLE Mem.MySQLiteTable (RecID INTEGER PRIMARY KEY, Char INTEGER NOT NULL, Str TEXT NOT NULL COLLATE NOCASE, Dec REAL NOT NULL)'
                        If ~SQLite.Exec()
                            Post(Event:CloseWindow)
                            Cycle
                        End
                        ?RandomProgress{Prop:Hide} = False
                        SQLite.ProgressControl = ?RandomProgress
                        SQLite.Exec('BEGIN TRANSACTION;INSERT INTO Mem.MySQLiteTable SELECT RecID,Char,Str,Dec FROM SQLiteTable;COMMIT')

                        Loc:UseSeqorName = Message('Populate Result Set to Queue using Ordinal # or Field Name?<13,13>It''s a bit slower using Field Names!','Queue population',Icon:Question,'Ordinal #|Field Name|Cancel')
                        ?RandomProgress{Prop:Hide} = True
                        Case Loc:UseSeqOrName
                        Of eCancel
                            Post(Event:CloseWindow)
                            Cycle
                        Of eByQFieldName
                            0{Prop:Text} = 0{Prop:Text} & ' (using Field Names)'
                        Else
                            0{Prop:Text} = 0{Prop:Text} & ' (using Ordinal No)'
                        End

                        ?RandomProgress{Prop:Hide} = False
                        Loop
                            MemQ.RecID = Random(1,CountQ.Count)
                            Get(MemQ,MemQ.RecID)
                            Case ErrorCode()
                            Of 00
                                !Try Again
                            Of 30
                                !Accum Time to Populate Q for SQLite Memory Table
                                Loc:BeginTime = Clock()
                                SQLite.CallbackQ &= MemQ
                                If  Loc:UseSeqorName <> eByQFieldName
                                    SQLite.Exec('SELECT * FROM Mem.MySQLiteTable WHERE RecID = '&MemQ.RecID)                       !Data     returned in MemQ by Ordinal Sequence
                                Else
                                    SQLite.Exec('SELECT Char,RecID,Dec,Str FROM Mem.MySQLiteTable WHERE RecID = '&MemQ.RecID,True) !Data NOT returned in MemQ by Ordinal Sequence
                                End
                                Loc:MemTime += Clock()-Loc:BeginTime

                                !Accum Time to Populate Q for SQLite Disk Table
                                Loc:BeginTime = Clock()
                                SQLite.CallbackQ &= SQLiteQ
                                If  Loc:UseSeqorName <> eByQFieldName
                                    SQLite.Exec('SELECT * FROM SQLiteTable WHERE RecID = '&MemQ.RecID)                         !Data     returned in SQLiteQ Ordinal Sequence
                                Else
                                    SQLite.Exec('SELECT Char,RecID,Dec,Str FROM SQLiteTable WHERE RecID = '&MemQ.RecID,True)   !Data NOT returned in SQLiteQ Ordinal Sequence
                                End
                                Loc:SQLiteTime += Clock()-Loc:BeginTime

                                Loc:RandomCount += 1
                                If  Loc:RandomCount%25=0
                                    ?RandomProgress{Prop:Progress} = Loc:RandomCount*100/(CountQ.Count/4)
                                End
                                If  Loc:RandomCount >= CountQ.Count/4
                                    Break
                                End
                            Else
                                Message('Random Reads Failed '&ErrorCode())
                                Break
                            End
                        End
                        ?RandomProgress{Prop:Hide} = True

                        ?MemList{Prop:Hide} = False
                        ?SQLiteMemMsg{Prop:Text} = 'SQLite MEMORY Data retrieved in ' & Loc:MemTime
                        ?SQLiteMemMsg{Prop:Hide} = False

                        ?SQLiteList{Prop:Hide} = False
                        ?SQLiteMsg{Prop:Text} = 'SQLite Disk Data retrieved in ' & Loc:SQLiteTime
                        ?SQLiteMsg{Prop:Hide} = False

                    Of  Event:CloseWindow
                        SQLite.Exec('DETACH ''Mem''')
                        !Message('Detach:' & SQLite.ReturnCodeMsg())
                        Free(MemQ)
                        Free(SQLiteQ)
                        Free(CountQ)
                    End
                End
                Close(DMWindow)


Lock_Database   Procedure(String pInstallBusyHandler,String pXPos)
LockWindow WINDOW,AT(,,142,59),CENTER,TIMER(1),GRAY,DOUBLE,FONT('MS Sans Serif',8,,FONT:regular)
       PROGRESS,USE(?ProgressBar),AT(16,23,111,12),RANGE(0,100)
     END

Loc:YPos        Long
Loc:Height      Long

                Code

                Open(LockWindow)
                Loc:YPos   = 0{Prop:At,2}
                Loc:Height = 0{Prop:At,4}
                0{Prop:At,1} = pXPos
                If  Thread()%2 = 0
                    0{Prop:At,2} = Loc:YPos - (Loc:Height/2)
                Else
                    0{Prop:At,2} = Loc:YPos + (Loc:Height/2)
                End
                Accept                                               
                    Case Event()
                    Of Event:OpenWindow
                        0{Prop:Text} = 'Lock Test on thread ' & Thread()
                        If ~SQLite.OpenDB('SQLite.DB')
                            Message('Unable to Open SQLite DB')
                            Post(Event:CloseWindow)
                            Cycle
                        End
                        If  pInstallBusyHandler = '1'
                            SQLite.InstallBusyHandler(3000) !3 seconds
                        End
                        Post(Event:User)
                    Of Event:User
                        Loop 10 Times
                            SQLite.ProgressControl = ?ProgressBar
                            If ~SQLite.Exec('UPDATE SQLiteTable SET Real = 3456')
                                If  SQLite.LastReturnCode = 5   !SQLite_Busy
                                    Cycle
                                End
                                Break
                            End
                        End
                        SQLite.CloseDB()
                        Post(Event:CloseWindow)
                    End
                End
                0{Prop:Active} = True
                Close(LockWindow)

