 Member

 Map
    Module('SQLite api')
        sqlite3_errmsg(Long),Long,C
        sqlite3_free(Long),C
        sqlite3_exec(Long,*cString,Long,Long,Long),Long,C,Raw
        sqlite3_close(Long),Long,C,Proc
        sqlite3_open(*cString,Long),Long,C,Raw
        sqlite3_progress_handler(Long,Long,Long,Long),C
        sqlite3_busy_timeout(Long,Long),Long,C,Proc
    End
    Module('Win32 api')
        MultiByteToWideChar(UNSIGNED,ULONG,Long,SIGNED,LONG,SIGNED),SIGNED,PASCAL
        WideCharToMultiByte(uLong,uLong,Long,Long,Long,Long,Long,Long),Long,Pascal
        GetDiskFreeSpace(Long,Long,Long,Long,Long),Raw,Pascal,Name('GetDiskFreeSpaceA')
        MemCpy(LONG,LONG,LONG),NAME('_memcpy')
        GetLastError(),ULONG,PASCAL
    End
 End

Include('SQLite.inc')

SQLITE_OK          Equate(  0)    !   /* Successful result */
SQLITE_ERROR       Equate(  1)    !   /* SQL error or missing database */
SQLITE_INTERNAL    Equate(  2)    !   /* An internal logic error in SQLite */
SQLITE_PERM        Equate(  3)    !   /* Access permission denied */
SQLITE_ABORT       Equate(  4)    !   /* Callback routine requested an abort */
SQLITE_BUSY        Equate(  5)    !   /* The database file is locked */
SQLITE_LOCKED      Equate(  6)    !   /* A table in the database is locked */
SQLITE_NOMEM       Equate(  7)    !   /* A malloc() failed */
SQLITE_READONLY    Equate(  8)    !   /* Attempt to write a readonly database */
SQLITE_INTERRUPT   Equate(  9)    !   /* Operation terminated by sqlite_interrupt() */
SQLITE_IOERR       Equate( 10)    !   /* Some kind of disk I/O error occurred */
SQLITE_CORRUPT     Equate( 11)    !   /* The database disk image is malformed */
SQLITE_NOTFOUND    Equate( 12)    !   /* (Internal Only) Table or record not found */
SQLITE_FULL        Equate( 13)    !   /* Insertion failed because database is full */
SQLITE_CANTOPEN    Equate( 14)    !   /* Unable to open the database file */
SQLITE_PROTOCOL    Equate( 15)    !   /* Database lock protocol error */
SQLITE_EMPTY       Equate( 16)    !   /* (Internal Only) Database table is empty */
SQLITE_SCHEMA      Equate( 17)    !   /* The database schema changed */
SQLITE_TOOBIG      Equate( 18)    !   /* Too much data for one row of a table */
SQLITE_CONSTRAINT  Equate( 19)    !   /* Abort due to contraint violation */
SQLITE_MISMATCH    Equate( 20)    !   /* Data type mismatch */
SQLITE_MISUSE      Equate( 21)    !   /* Library used incorrectly */
SQLITE_NOLFS       Equate( 22)    !   /* Uses OS features not supported on host */
SQLITE_AUTH        Equate( 23)    !   /* Authorization denied */
SQLITE_ROW         Equate(100)    !   /* sqlite_step() has another row ready */
SQLITE_DONE        Equate(101)    !   /* sqlite_step() has finished executing */


!Code Pages
CP_ACP                                EQUATE(0 )!          // default to ANSI code page
CP_OEMCP                              EQUATE(1 )!          // default to OEM  code page
CP_MACCP                              EQUATE(2 )!          // default to MAC  code page
CP_THREAD_ACP                         EQUATE(3 )!          // current thread's ANSI code page
CP_SYMBOL                             EQUATE(42)!          // SYMBOL translations
CP_UTF7                               EQUATE(65000)!       // UTF-7 translation
CP_UTF8                               EQUATE(65001)!       // UTF-8 translation

!Multibyte to WideChar (Unicode) translation flags
MB_PRECOMPOSED                        EQUATE(000000001)!  // use precomposed chars
MB_COMPOSITE                          EQUATE(000000002)!  // use composite chars
MB_USEGLYPHCHARS                      EQUATE(000000004)!  // use glyph chars, not ctrl chars
MB_ERR_INVALID_CHARS                  EQUATE(000000008)!  // error for invalid chars

!WideChar (Unicode) to Multibyte translation flags
WC_COMPOSITECHECK                     EQUATE(000000200)!  // convert composite to precomposed
WC_DISCARDNS                          EQUATE(000000010)!  // discard non-spacing chars
WC_SEPCHARS                           EQUATE(000000020)!  // generate separate chars
WC_DEFAULTCHAR                        EQUATE(000000040)!  // replace w/ default char

ERROR_INSUFFICIENT_BUFFER             Equate(122)       ! The data area passed to a system call is too small.
ERROR_INVALID_FLAGS                   Equate(1004)      ! Invalid flags.
ERROR_INVALID_PARAMETER               Equate( 87)       ! The parameter is incorrect.
ERROR_NO_UNICODE_TRANSLATION          Equate(1113)      ! No mapping for the Unicode character exists in the target multi-byte code page.




CBQFieldsQType     Queue,Type
OrdinalPos              Long
FieldName               String(20)
                    End



!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! SQLite Class !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

SQLiteType.Callback     Procedure(Long pArgC,Long pArgV,Long pCol)
Loc:ValuePtr            Long
Loc:ColumnPtr           Long
Loc:Column              &cString
Loc:Value               &cString

Loc:Index               Long
Loc:OffSet              Long(0)
Loc:FldRef              Any
                        CODE

                        Clear(Self.CallbackQ)
                        Loop Loc:Index = 1 to pArgC
                            Loc:OffSet = 4 * (Loc:Index-1)

                            !Get Value
                            MemCpy(Address(Loc:ValuePtr),pArgV+Loc:OffSet,4)       !1st Dereference
                            Loc:Value &= (Loc:ValuePtr)                            !2nd Dereference
                            Self.UTF8toACP(Loc:Value)

                            If ~Self.UseFieldMatching
                                Loc:FldRef &= What(Self.CallbackQ,Loc:Index)
                                If ~Loc:FldRef &= Null
                                    Loc:FldRef  = Loc:Value
                                End
                            Else
                                !Get Column
                                MemCpy(Address(Loc:ColumnPtr),pCol+Loc:OffSet,4)
                                Loc:Column &= (Loc:ColumnPtr)
                                Self.UTF8toACP(Loc:Column)
                                !Get Ordinal Position
                                Self.CBQFieldsQ.FieldName = Upper(Clip(Loc:Column))
                                Get(Self.CBQFieldsQ,Self.CBQFieldsQ.FieldName)
                                If ~ErrorCode()
                                    Loc:FldRef &= What(Self.CallbackQ,Self.CBQFieldsQ.OrdinalPos)
                                    If ~Loc:FldRef &= Null
                                        Loc:FldRef  = Loc:Value
                                    End
                                End
                            End
                        End
                        Add(Self.CallbackQ)
                        Self.CallbackCount += 1
                        If  Self.ProgressControl
                            If  Self.CallbackCount % Self.ProgressInterval = 0
                                Self.ProgressControl{Prop:Progress} = Self.CallbackCount * 100 / Self.ProgressTotal
                            End
                        End

                        Return SQLITE_OK


SQLiteType.OpenDB               Procedure(String pDBName)
Loc:Exists                      Byte
Loc:Len                         Long
Loc:DBName                      &cString

Loc:DriveLet                    String(1)
Loc:DriveNum                    Byte
Loc:DriveName                   cString(10)
Loc:SectorsPerCluster           Long
Loc:BytesPerSector              Long
Loc:FreeClusters                Long
Loc:Clusters                    Long
Loc:ClusterSize                 Long

                        Code
                        Loc:Len = Len(Clip(pDBName))
                        If  Self.DBName &= Null
                            Self.DBName &= New(cString(Loc:Len*3+1))
                            If  Self.DBName &= Null
                                Return False
                            End
                            Self.DBName = pDBName
                            Self.ACPtoUTF8(Self.DBName)
                        Else
                            Loc:DBName &= New(cString(Loc:Len*3+1))
                            If  Loc:DBName &= Null
                                Return False
                            End
                            Loc:DBName = pDBName
                            Self.ACPtoUTF8(Loc:DBName)
                            If  Loc:DBName = Self.DBName |
                            And Self.hSQLite
                                !Already have handle to this DB
                                Dispose(Loc:DBName)
                                Return True
                            End
                            Self.CloseDB()
                            Self.DBName &= Loc:DBName
                            Loc:DBName  &= Null
                        End


                        Loc:Exists = Exists(Self.DBName)
                        Self.LastReturnCode = sqlite3_open(Self.DBName,Address(Self.hSQLite))
                        If  Self.LastReturnCode <> SQLITE_OK
                            Self.CloseDB()
                            Return False
                        End

                        Self.Exec('PRAGMA synchronous=0')       !0=Off, 1=Normal, 2=Full
                        Self.Exec('PRAGMA temp_store=2')        !0=Default, 1=File, 2=MEMORY

                        If ~Loc:Exists
                            !Get the Cluster size and set page_size accordingly
                            !NTFS default cluster size is 4096
                            Loc:DriveLet = Path()
                            Loc:DriveNum = Val(Loc:DriveLet) - 64
                            Loc:DriveName = Loc:DriveLet & ':\'
                            GetDiskFreeSpace( Address(Loc:DriveName), |
                                              Address(Loc:SectorsPerCluster), |
                                              Address(Loc:BytesPerSector), |
                                              Address(Loc:FreeClusters), |
                                              Address(Loc:Clusters) )
                            Loc:ClusterSize = Loc:BytesPerSector * Loc:SectorsPerCluster
                            If  2^9  = Loc:ClusterSize |  ! 512
                            Or  2^10 = Loc:ClusterSize |  !1024
                            Or  2^11 = Loc:ClusterSize |  !2048
                            Or  2^12 = Loc:ClusterSize |  !4096
                            Or  2^13 = Loc:ClusterSize    !8192
                                Self.Exec('PRAGMA page_size=' & Loc:ClusterSize)
                            End
                        End


                        Return True



SQLiteType.ACPtoUTF8            Procedure(*cString pInOut)
                                !Translate ANSI code page characters to unicode UTF8
                                !*** Ensure pInOut is big enough when calling this method ***
Loc:Return                      Long(False)
Loc:RC                          Long
Loc:WLen                        Long
Loc:WideCharStr                 &cString
                                Code
                                If  Len(pInOut)
                                    Loc:WLen = MultiByteToWideChar(CP_ACP, MB_PRECOMPOSED, Address(pInOut), -1, 0, 0)
                                    Loc:WideCharStr &= New(cString(Loc:WLen*2))
                                    If ~Loc:WideCharStr &= Null
                                        Loc:RC = MultiByteToWideChar(CP_ACP, MB_PRECOMPOSED, Address(pInOut), -1, Address(Loc:WideCharStr), Loc:WLen)
                                        If  Loc:RC
                                            Loc:RC = WideCharToMultiByte(CP_UTF8,0,Address(Loc:WideCharStr),-1,Address(pInOut),Size(pInOut),0,0)
                                            If  Loc:RC
                                                Loc:Return = True
                                            Else
                                                Case GetLastError()
                                                Of  ERROR_INSUFFICIENT_BUFFER
                                                    Message('The data area passed to a system call is too small.','WideCharToMultiByte')
                                                Of  ERROR_INVALID_FLAGS
                                                    Message('Invalid flags.','WideCharToMultiByte')
                                                Of  ERROR_INVALID_PARAMETER
                                                    Message('The parameter is incorrect.','WideCharToMultiByte')
                                                End
                                            End
                                        Else
                                            Case GetLastError()
                                            Of  ERROR_INSUFFICIENT_BUFFER
                                                Message('The data area passed to a system call is too small.','MultiByteToWideChar')
                                            Of  ERROR_INVALID_FLAGS
                                                Message('Invalid flags.','MultiByteToWideChar')
                                            Of  ERROR_INVALID_PARAMETER
                                                Message('The parameter is incorrect.','MultiByteToWideChar')
                                            Of  ERROR_NO_UNICODE_TRANSLATION
                                                Message('No mapping for the Unicode character exists in the target multi-byte code page.','MultiByteToWideChar')
                                            End
                                        End
                                        Dispose(Loc:WideCharStr)
                                    Else
                                        Message('Failed to create instance of Loc:WideCharStr')
                                    End
                                End
                                Return Loc:Return


SQLiteType.UTF8toACP            Procedure(*cString pInOut)
                                !Unicode UTF8 to ANSI code page characters
Loc:Return                      Long(False)
Loc:RC                          Long
Loc:WLen                        Long
Loc:WideCharStr                 &cString
                                Code
                                Loc:WLen = MultiByteToWideChar(CP_UTF8, 0, Address(pInOut), -1, 0, 0)
                                If  Loc:WLen > 0
                                    Loc:WideCharStr &= New(cString(Loc:WLen*2))
                                    If ~Loc:WideCharStr &= Null
                                        Loc:RC = MultiByteToWideChar(CP_UTF8, 0, Address(pInOut), -1, Address(Loc:WideCharStr), Loc:WLen)
                                        If  Loc:RC
                                            Loc:RC = WideCharToMultiByte(CP_ACP,0,Address(Loc:WideCharStr),-1,Address(pInOut),Size(pInOut),0,0)
                                            If  Loc:RC
                                                Loc:Return = True
                                            Else
                                                Case GetLastError()
                                                Of  ERROR_INSUFFICIENT_BUFFER
                                                    Message('The data area passed to a system call is too small.','WideCharToMultiByte')
                                                Of  ERROR_INVALID_FLAGS
                                                    Message('Invalid flags.','WideCharToMultiByte')
                                                Of  ERROR_INVALID_PARAMETER
                                                    Message('The parameter is incorrect.','WideCharToMultiByte')
                                                End
                                            End
                                        Else
                                            Case GetLastError()
                                            Of  ERROR_INSUFFICIENT_BUFFER
                                                Message('The data area passed to a system call is too small.','MultiByteToWideChar')
                                            Of  ERROR_INVALID_FLAGS
                                                Message('Invalid flags.','MultiByteToWideChar')
                                            Of  ERROR_INVALID_PARAMETER
                                                Message('The parameter is incorrect.','MultiByteToWideChar')
                                            Of  ERROR_NO_UNICODE_TRANSLATION
                                                Message('No mapping for the Unicode character exists in the target multi-byte code page.','MultiByteToWideChar')
                                            End
                                        End
                                        Dispose(Loc:WideCharStr)
                                    Else
                                        Message('Failed to create instance of Loc:WideCharStr')
                                    End
                                End
                                Return Loc:Return


SQLiteType.CloseDB      Procedure()
                        Code
                        If  Self.hSQLite
                            sqlite3_close(Self.hSQLite)
                            Self.hSQLite = 0
                        End
                        If ~Self.DBName &= Null
                            Dispose(Self.DBName)
                        End

                        !Callback to update GUI Progress, without any calibration
SQLiteType.Progress     Procedure()
                        Code
                        Self.ProgressCount += 1
                        Self.ProgressControl{Prop:Progress} = Self.ProgressCount % 100
                        Return 0


SQLiteType.InstallBusyHandler Procedure(Long pMilliseconds)
                        Code
                        SQLite3_busy_timeout(Self.hSQLite,pMilliseconds)


SQLiteType.Exec         Procedure(<String pSQL>,Long pUseFieldMatching=False)
Loc:OrdinalPos          Long
Loc:ErrorMsg            &cString
Loc:ErrorMsgPtr         Long


                        Code
                        Self.LastReturnCode = SQLITE_OK
                        Loc:ErrorMsgPtr = 0

                        If ~Omitted(pSQL)
                            Self.SQL = pSQL
                        End

                        If ~Self.ACPtoUTF8(Self.SQL)
                            Return False
                        End


                        If  Self.CallBackQ &= Null
                            !Self.Callback NOT used
                            If ~Self.ProgressControl
                                Self.LastReturnCode = sqlite3_exec(Self.hSQLite,Self.SQL,0,0,Address(Loc:ErrorMsgPtr))
                            Else
                                Self.ProgressControl{Prop:Range,1}  = 0
                                Self.ProgressControl{Prop:Range,2}  = 100
                                Self.ProgressControl{Prop:Progress} = 0
                                Self.ProgressCount=0
                                If  Self.ProgressInterval=0
                                    Self.ProgressInterval=1000      !Virtual machine opcodes (can only guess)
                                End
                                sqlite3_progress_handler(Self.hSQLite,Self.ProgressInterval,Address(Self.Progress),Address(Self))
                                Self.LastReturnCode = sqlite3_exec(Self.hSQLite,Self.SQL,0,0,Address(Loc:ErrorMsgPtr))
                                sqlite3_progress_handler(Self.hSQLite,0,0,0)
                                Self.ProgressControl{Prop:Progress} = 100
                                Self.ProgressInterval = 0
                                Self.ProgressControl  = 0
                            End
                        Else
                            !Self.Callback used to populate CallbackQ
                            If  pUseFieldMatching = True
                                !Populate Q using Field Name Matching
                                Free(Self.CBQFieldsQ)
                                Loop
                                    Loc:OrdinalPos += 1
                                    Self.CBQFieldsQ.FieldName = Upper(Who(Self.CallbackQ,Loc:OrdinalPos))
                                    If ~Self.CBQFieldsQ.FieldName
                                        Break
                                    End
                                    Self.CBQFieldsQ.OrdinalPos = Loc:OrdinalPos
                                    Add(Self.CBQFieldsQ)
                                End
                                Self.UseFieldMatching = True
                            Else
                                !Populate Q using Ordinal Number Sequence
                                Self.UseFieldMatching = False
                            End
                            Self.CallbackCount = 0
                            If  Self.ProgressControl
                                Self.ProgressControl{Prop:Range,1}  = 0
                                Self.ProgressControl{Prop:Range,2}  = 100
                                Self.ProgressControl{Prop:Progress} = 0
                                If ~Self.ProgressTotal
                                    Self.ProgressTotal    = 5000
                                End
                                If ~Self.ProgressInterval
                                    Self.ProgressInterval = Self.ProgressTotal / 25
                                End
                            End
                            Self.LastReturnCode = sqlite3_exec(Self.hSQLite,Self.SQL,Address(Self.Callback),Address(Self),Address(Loc:ErrorMsgPtr))
                            !Clean Up
                            If  Self.ProgressControl
                                Self.ProgressControl{Prop:Progress} = 100
                                Self.ProgressControl  = 0
                                Self.ProgressTotal    = 0
                                Self.ProgressInterval = 0
                            End
                            Self.CallBackQ &= Null
                            If  Self.UseFieldMatching = True
                                Free(Self.CBQFieldsQ)
                                Self.UseFieldMatching = False
                            End

                        End


                        If  Loc:ErrorMsgPtr
                            Loc:ErrorMsg &= (Loc:ErrorMsgPtr)
                            Self.UTF8toACP(Loc:ErrorMsg)
                            Message(Self.SQL & '<13,13>' & Self.ReturnCodeMsg()& '<13,13>' & Loc:ErrorMsg & '<13,13>Thread ' & Thread() ,'Error on SQLite Exec')
                            sqlite3_free(Loc:ErrorMsgPtr)
                            Loc:ErrorMsg &= Null
                            Return False
                        Elsif Self.LastReturnCode <> SQLITE_OK
                            Message(Self.SQL & '<13,13>' & Self.ReturnCodeMsg() &  '<13,13>Thread ' & Thread() ,'Error on SQLite Exec')
                            Return False
                        Else
                            Return True
                        End


SQLiteType.ReturnCodeMsg    Procedure(<Long pCode>)
Loc:Code                    Long
                            Code
                            If  Omitted(pCode)
                                Loc:Code = Self.LastReturnCode
                            Else
                                Loc:Code = pCode
                            End
                            Case Loc:Code
                            Of  SQLITE_OK          !Equate(  0)
                                Return 'Successful result'
                            Of  SQLITE_ERROR       !Equate(  1)
                                Return 'SQL error or missing database'
                            Of  SQLITE_INTERNAL    !Equate(  2)
                                Return 'An internal logic error in SQLite'
                            Of  SQLITE_PERM        !Equate(  3)
                                Return 'Access permission denied'
                            Of  SQLITE_ABORT       !Equate(  4)
                                Return 'Callback routine requested an abort'
                            Of  SQLITE_BUSY        !Equate(  5)
                                Return 'The database file is locked'
                            Of  SQLITE_LOCKED      !Equate(  6)
                                Return 'A table in the database is locked'
                            Of  SQLITE_NOMEM       !Equate(  7)
                                Return 'A malloc() failed'
                            Of  SQLITE_READONLY    !Equate(  8)
                                Return 'Attempt to write a readonly database'
                            Of  SQLITE_INTERRUPT   !Equate(  9)
                                Return 'Operation terminated by sqlite_interrupt()'
                            Of  SQLITE_IOERR       !Equate( 10)
                                Return 'Some kind of disk I/O error occurred'
                            Of  SQLITE_CORRUPT     !Equate( 11)
                                Return 'The database disk image is malformed'
                            Of  SQLITE_NOTFOUND    !Equate( 12)
                                Return '(Internal Only) Table or record not found'
                            Of  SQLITE_FULL        !Equate( 13)
                                Return 'Insertion failed because database is full'
                            Of  SQLITE_CANTOPEN    !Equate( 14)
                                Return 'Unable to open the database file'
                            Of  SQLITE_PROTOCOL    !Equate( 15)
                                Return 'Database lock protocol error'
                            Of  SQLITE_EMPTY       !Equate( 16)
                                Return '(Internal Only) Database table is empty'
                            Of  SQLITE_SCHEMA      !Equate( 17)
                                Return 'The database schema changed'
                            Of  SQLITE_TOOBIG      !Equate( 18)
                                Return 'Too much data for one row of a table'
                            Of  SQLITE_CONSTRAINT  !Equate( 19)
                                Return 'Abort due to contraint violation'
                            Of  SQLITE_MISMATCH    !Equate( 20)
                                Return 'Data type mismatch'
                            Of  SQLITE_MISUSE      !Equate( 21)
                                Return 'Library used incorrectly'
                            Of  SQLITE_NOLFS       !Equate( 22)
                                Return 'Uses OS features not supported on host'
                            Of  SQLITE_AUTH        !Equate( 23)
                                Return 'Authorization denied'
                            Of  SQLITE_ROW         !Equate(100)
                                Return 'sqlite_step() has another row ready'
                            Of  SQLITE_DONE        !Equate(101)
                                Return 'sqlite_step() has finished executing'
                            Else
                                Return('Unknown SQLite Code ' & pCode)
                            End




SQLiteType.Construct        Procedure()
                            Code
                            Self.CBQFieldsQ &= New(CBQFieldsQType)
                            If  Self.CBQFieldsQ &= Null
                                Message('Problem Encountered creating instance of CBQFieldsQType')
                            End


SQLiteType.Destruct         Procedure()
                            Code
                            Self.CloseDB()
                            Free(Self.CBQFieldsQ)
                            Dispose(Self.CBQFieldsQ)




